import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.*;
import javax.imageio.ImageIO;

/**
 * Title:        Viech-Applikation
 * Description:  Spinnen rennen in einer Box rum
 * Copyright:    Copyright (c) 2021
 * Company:      MezData
 * @author Oliver Mezger
 * @version 13.2.1
 */

public class Oberflaeche extends JPanel {
  public static final String PROGRAMM_TITEL = "SimLive 13.2.1 (c) MezData '2021";
  private JLabel versi = new JLabel(Oberflaeche.PROGRAMM_TITEL);
  private JButton exit = new JButton("Exit");
  private int ortX= 50,ortY=50;
  private Steuerung dieSteuerung;// = new Steuerung(this);
  public BufferedImage fliege[] = new BufferedImage[5];
  public BufferedImage spinne[] = new BufferedImage[5];
  
  public Oberflaeche(){
    setBackground(Color.yellow);
    setLayout(new FlowLayout());
    add(versi);
    add(exit);
    exit.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        System.exit(0);
      }
    });
    addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        canvas_mousePressed(e);
      }
    });
    int i;
    try{
      for (i=0;i<fliege.length;i++)  
        fliege[i] = ImageIO.read(getClass().getResource("fliege-"+i+".gif"));
      for (i=0;i<spinne.length;i++) 
        spinne[i] = ImageIO.read(getClass().getResource("spinne-"+i+".gif"));
    } 
    catch (IOException e){ 
      System.out.println ("Datei konnte nicht geladen werden!"); 
      System.exit(1); 
    }
    Fliege.tierArt=fliege;
    Spider.tierArt=spinne;
    dieSteuerung = new Steuerung(this);
  }
  
  public void paint(Graphics g)  {
    super.paint(g);
    dieSteuerung.malen(g);
    g.setColor(Color.blue);
    g.fillOval(ortX-3, ortY-3, 6, 6);
  }
  
  public void canvas_mousePressed(MouseEvent e) {
    ortX=e.getX();
    ortY=e.getY();    
    if (e.isShiftDown())
      dieSteuerung.shiftKlick(ortX,ortY);
    else
      dieSteuerung.klick(ortX,ortY);
    repaint();
  }
  
  public static void main(String[] args) {
    JFrame fr = new JFrame();  //die Oberflaeche wird erzeugt
    Oberflaeche ober = new Oberflaeche();
    fr.getContentPane().add(ober);
    fr.addWindowListener(new WindowAdapter(){  // Objekt soll beendet werden k?nnen
       public void windowClosing(WindowEvent e) {
         System.exit(0);
       }
    });
    fr.setSize(700,700); //die Groesse der Box wird festgelegt
    fr.setTitle(PROGRAMM_TITEL);
    fr.setVisible(true);  
  }
}