import java.awt.*;
import java.util.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;

public abstract class Viech{
  protected int ortX,ortY,tierTyp;
  protected double groesse;
  protected double laufRichtung; // Laufrichtung im Bogenmass 360 Grad = 2*Pi
  private double oldLaufRichtung =-1; 
  protected Image tierBild[];
  protected BufferedImage tempImage;

  public Viech(int x,int y,double gr,int tt){
    ortX=x;
	ortY=y;
	groesse = gr;
	laufRichtung = 2*Math.PI*(Math.random());
	tierTyp = tt;
  }
  
  public int getX() { return ortX; }
  public int getY() { return ortY; }
  public double getGroesse() { return groesse; }
  public int getTt() { return tierTyp; }

  public void malen(Graphics g){
    checkBorder(g.getClipBounds()); // dabei erst mal checken, ob es im Rahmen bleibt
    if (laufRichtung != oldLaufRichtung){
      oldLaufRichtung=laufRichtung;
      int width = tierBild[tierTyp].getWidth(null); 
      int height = tierBild[tierTyp].getHeight(null); 
      Graphics2D graphics = tempImage.createGraphics();
      graphics.setBackground(new Color(0,true));
      graphics.setRenderingHint(RenderingHints.KEY_INTERPOLATION,RenderingHints.VALUE_INTERPOLATION_BILINEAR); 
      AffineTransform trans = AffineTransform.getRotateInstance(laufRichtung,width >> 1, height >> 1); 
      graphics.clearRect(0,0, width, height); 
      graphics.drawImage(tierBild[tierTyp], trans, null);
    }
    g.drawImage(tempImage,ortX-(int)groesse/2, ortY-(int)groesse/2, (int)groesse, (int)groesse,null); 
  }
  
  public void geheZu(int x, int y){
    double dx, dy;
    dx = x-ortX;
    dy = ortY-y;
    laufRichtung = Math.atan2(dx,dy);
  }
  
  public boolean getroffen(int x, int y){
    int dx, dy;
    dx = ortX -x;
    dy = ortY -y;
    return Math.sqrt(dx*dx+dy*dy) < groesse /2;
  }
  
  public void leben(Vector v){
    ortX += (int)(Math.sin(laufRichtung)*groesse*(1+tierTyp/3)/30);
    ortY -= (int)(Math.cos(laufRichtung)*groesse*(1+tierTyp/3)/30);
  } 
  
  void checkBorder(Rectangle r){  // berprfen ob ein Rand verletzt wird
    boolean b = false;           // Wir gehen nicht davon aus
    if (ortX < groesse/2){
      ortX = (int)groesse/2;          // Abstand halten
      b = true;                // Die Richtung ist nicht mehr gut.
    }
    else if (ortX > r.width-groesse/2){
      ortX = r.width-(int)groesse/2;
      b = true;
    }
    if (ortY < groesse/2){
      ortY = (int)groesse/2;
      b = true;
    }
    else if (ortY > r.height-groesse/2){
      ortY = r.height-(int)groesse/2;
      b = true;
    }
    if (b){
      laufRichtung += 2*Math.PI*(Math.random()-0.4);  // Wir kehren um
      if (laufRichtung > 2*Math.PI) laufRichtung -= 2*Math.PI;  // nicht berdrehen 
    }
  }
  
  int gibDistanzZu(Viech a){
     int dx,dy;  
     dx = a.getX()-ortX;
     dy = a.getY()-ortY;
     return (int)Math.sqrt(dx*dx+dy*dy);
  }
  void showDebugInfo(Graphics g){
    g.setColor(Color.black);    
    g.drawLine(ortX, ortY, (int)(ortX+groesse/2*Math.sin(laufRichtung)), (int)(ortY-groesse/2*Math.cos(laufRichtung)));    
  }
}
